# ncurses 6.0 - patch 20170827 - Thomas E. Dickey
#
# ------------------------------------------------------------------------------
#
# Ncurses 6.0 is at
# 	ftp.gnu.org:/pub/gnu
#
# Patches for ncurses 6.0 can be found at
# 	ftp://ftp.invisible-island.net/ncurses/6.0
#	http://invisible-mirror.net/archives/ncurses/6.0 
#
# ------------------------------------------------------------------------------
# ftp://ftp.invisible-island.net/ncurses/6.0/ncurses-6.0-20170827.patch.gz
# patch by Thomas E. Dickey <dickey@invisible-island.net>
# created  Sun Aug 27 21:32:11 UTC 2017
# ------------------------------------------------------------------------------
# NEWS                             |    5 ++++-
# VERSION                          |    2 +-
# dist.mk                          |    4 ++--
# ncurses/tty/tty_update.c         |   13 ++++++++-----
# package/debian-mingw/changelog   |    4 ++--
# package/debian-mingw64/changelog |    4 ++--
# package/debian/changelog         |    4 ++--
# package/mingw-ncurses.nsi        |    4 ++--
# package/mingw-ncurses.spec       |    2 +-
# package/ncurses.spec             |    2 +-
# 10 files changed, 25 insertions(+), 19 deletions(-)
# ------------------------------------------------------------------------------
Index: NEWS
Prereq:  1.2935 
--- ncurses-6.0-20170826+/NEWS	2017-08-26 21:33:48.000000000 +0000
+++ ncurses-6.0-20170827/NEWS	2017-08-27 18:35:58.000000000 +0000
@@ -25,7 +25,7 @@
 -- sale, use or other dealings in this Software without prior written        --
 -- authorization.                                                            --
 -------------------------------------------------------------------------------
--- $Id: NEWS,v 1.2935 2017/08/26 21:33:48 tom Exp $
+-- $Id: NEWS,v 1.2937 2017/08/27 18:35:58 tom Exp $
 -------------------------------------------------------------------------------
 
 This is a log of changes that ncurses has gone through since Zeyd started
@@ -45,6 +45,9 @@
 Changes through 1.9.9e did not credit all contributions;
 it is not possible to add this information.
 
+20170827
+	+ fix a bug in repeat_char logic (cf: 20170729, report by Chris Clayton).
+
 20170826
 	+ fixes for "iterm2" (report by Leonardo Brondani Schenkel) -TD
 	+ corrected a warning from tic about keys which are the same, to skip
Index: VERSION
--- ncurses-6.0-20170826+/VERSION	2017-08-20 15:33:41.000000000 +0000
+++ ncurses-6.0-20170827/VERSION	2017-08-27 15:37:47.000000000 +0000
@@ -1 +1 @@
-5:0:9	6.0	20170826
+5:0:9	6.0	20170827
Index: dist.mk
Prereq:  1.1179 
--- ncurses-6.0-20170826+/dist.mk	2017-08-20 15:33:41.000000000 +0000
+++ ncurses-6.0-20170827/dist.mk	2017-08-27 15:37:47.000000000 +0000
@@ -25,7 +25,7 @@
 # use or other dealings in this Software without prior written               #
 # authorization.                                                             #
 ##############################################################################
-# $Id: dist.mk,v 1.1179 2017/08/20 15:33:41 tom Exp $
+# $Id: dist.mk,v 1.1180 2017/08/27 15:37:47 tom Exp $
 # Makefile for creating ncurses distributions.
 #
 # This only needs to be used directly as a makefile by developers, but
@@ -37,7 +37,7 @@
 # These define the major/minor/patch versions of ncurses.
 NCURSES_MAJOR = 6
 NCURSES_MINOR = 0
-NCURSES_PATCH = 20170826
+NCURSES_PATCH = 20170827
 
 # We don't append the patch to the version, since this only applies to releases
 VERSION = $(NCURSES_MAJOR).$(NCURSES_MINOR)
Index: ncurses/tty/tty_update.c
Prereq:  1.294 
--- ncurses-6.0-20170826+/ncurses/tty/tty_update.c	2017-07-31 21:06:04.000000000 +0000
+++ ncurses-6.0-20170827/ncurses/tty/tty_update.c	2017-08-27 19:40:17.000000000 +0000
@@ -84,7 +84,7 @@
 
 #include <ctype.h>
 
-MODULE_ID("$Id: tty_update.c,v 1.294 2017/07/31 21:06:04 tom Exp $")
+MODULE_ID("$Id: tty_update.c,v 1.296 2017/08/27 19:40:17 tom Exp $")
 
 /*
  * This define controls the line-breakout optimization.  Every once in a
@@ -668,7 +668,9 @@
 		}
 	    } else if (repeat_char != 0 &&
 #if USE_WIDEC_SUPPORT
-		       (CharOf(ntext0) < ACS_LEN) &&
+		       (!SP_PARM->_screen_unicode &&
+			((AttrOf(ntext0) & A_ALTCHARSET) == 0 ||
+			 (CharOf(ntext0) < ACS_LEN))) &&
 #endif
 		       runcount > SP_PARM->_rep_cost) {
 		NCURSES_CH_T temp;
@@ -682,10 +684,11 @@
 		UpdateAttrs(SP_PARM, ntext0);
 		temp = ntext0;
 		if ((AttrOf(temp) & A_ALTCHARSET) &&
-		    SP_PARM->_acs_map != 0) {
+		    SP_PARM->_acs_map != 0 &&
+		    (SP_PARM->_acs_map[CharOf(temp)] & A_CHARTEXT) != 0) {
 		    SetChar(temp,
-			    SP_PARM->_acs_map[CharOf(temp)],
-			    AttrOf(temp) | A_ALTCHARSET);
+			    (SP_PARM->_acs_map[CharOf(ntext0)] & A_CHARTEXT),
+			    AttrOf(ntext0) | A_ALTCHARSET);
 		}
 		NCURSES_SP_NAME(tputs) (NCURSES_SP_ARGx
 					TPARM_2(repeat_char,
Index: package/debian-mingw/changelog
--- ncurses-6.0-20170826+/package/debian-mingw/changelog	2017-08-20 15:33:41.000000000 +0000
+++ ncurses-6.0-20170827/package/debian-mingw/changelog	2017-08-27 15:37:47.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (6.0+20170826) unstable; urgency=low
+ncurses6 (6.0+20170827) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 20 Aug 2017 11:33:41 -0400
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 27 Aug 2017 11:37:47 -0400
 
 ncurses6 (5.9-20131005) unstable; urgency=low
 
Index: package/debian-mingw64/changelog
--- ncurses-6.0-20170826+/package/debian-mingw64/changelog	2017-08-20 15:33:41.000000000 +0000
+++ ncurses-6.0-20170827/package/debian-mingw64/changelog	2017-08-27 15:37:47.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (6.0+20170826) unstable; urgency=low
+ncurses6 (6.0+20170827) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 20 Aug 2017 11:33:41 -0400
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 27 Aug 2017 11:37:47 -0400
 
 ncurses6 (5.9-20131005) unstable; urgency=low
 
Index: package/debian/changelog
--- ncurses-6.0-20170826+/package/debian/changelog	2017-08-20 15:33:41.000000000 +0000
+++ ncurses-6.0-20170827/package/debian/changelog	2017-08-27 15:37:47.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (6.0+20170826) unstable; urgency=low
+ncurses6 (6.0+20170827) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 20 Aug 2017 11:33:41 -0400
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 27 Aug 2017 11:37:47 -0400
 
 ncurses6 (5.9-20120608) unstable; urgency=low
 
Index: package/mingw-ncurses.nsi
Prereq:  1.227 
--- ncurses-6.0-20170826+/package/mingw-ncurses.nsi	2017-08-20 15:33:41.000000000 +0000
+++ ncurses-6.0-20170827/package/mingw-ncurses.nsi	2017-08-27 15:37:47.000000000 +0000
@@ -1,4 +1,4 @@
-; $Id: mingw-ncurses.nsi,v 1.227 2017/08/20 15:33:41 tom Exp $
+; $Id: mingw-ncurses.nsi,v 1.228 2017/08/27 15:37:47 tom Exp $
 
 ; TODO add examples
 ; TODO bump ABI to 6
@@ -10,7 +10,7 @@
 !define VERSION_MAJOR "6"
 !define VERSION_MINOR "0"
 !define VERSION_YYYY  "2017"
-!define VERSION_MMDD  "0826"
+!define VERSION_MMDD  "0827"
 !define VERSION_PATCH ${VERSION_YYYY}${VERSION_MMDD}
 
 !define MY_ABI   "5"
Index: package/mingw-ncurses.spec
--- ncurses-6.0-20170826+/package/mingw-ncurses.spec	2017-08-20 15:33:41.000000000 +0000
+++ ncurses-6.0-20170827/package/mingw-ncurses.spec	2017-08-27 15:37:47.000000000 +0000
@@ -3,7 +3,7 @@
 Summary: shared libraries for terminal handling
 Name: mingw32-ncurses6
 Version: 6.0
-Release: 20170826
+Release: 20170827
 License: X11
 Group: Development/Libraries
 Source: ncurses-%{version}-%{release}.tgz
Index: package/ncurses.spec
--- ncurses-6.0-20170826+/package/ncurses.spec	2017-08-20 15:33:41.000000000 +0000
+++ ncurses-6.0-20170827/package/ncurses.spec	2017-08-27 15:37:47.000000000 +0000
@@ -1,7 +1,7 @@
 Summary: shared libraries for terminal handling
 Name: ncurses6
 Version: 6.0
-Release: 20170826
+Release: 20170827
 License: X11
 Group: Development/Libraries
 Source: ncurses-%{version}-%{release}.tgz
